//+------------------------------------------------------------------+
//|                                             Gann HiLo - bars.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Original introduced by Robert Krausz                             |
//| (February 1998, Stocks & Commodities Magazine                    |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers  2
#property indicator_color1   DeepSkyBlue
#property indicator_color2   PaleVioletRed
#property  indicator_width1  5
#property  indicator_width2  5

//
//
//
//
//
//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Lb              = 19;
extern double arrowsDistance  = 1.0;
extern string _               = "alerts settings";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double arrowUp[];
double arrowDn[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(3);
   SetIndexBuffer(0,arrowUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,177);
   SetIndexBuffer(1,arrowDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,177);
   SetIndexBuffer(2,trend);
   
     //
     //
     //
     //
     //
      
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
     //
     //
     //
     //
     //
   
 IndicatorShortName(timeFrameToString(timeFrame)+"  Gann HiLo activator arrows");
 return(0);
}

//
//
//
//
//

int deinit(){  return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (returnBars)  { arrowUp[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {

       for(i=limit;i>=0;i--)
       {
             arrowUp[i] = EMPTY_VALUE;
             arrowDn[i] = EMPTY_VALUE;
             trend[i]   = trend[i+1];
             
                if(Close[i] > iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1)) trend[i] =  1;
                if(Close[i] < iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW, i+1)) trend[i] = -1;
      
                if(trend[i]!=trend[i+1])
                { 
                   if(trend[i] ==  1) arrowUp[i] = Low[i] - arrowsDistance * iATR(NULL,0,20,i);
                   if(trend[i] == -1) arrowDn[i] = High[i]+ arrowsDistance * iATR(NULL,0,20,i);
                } 
                
    }

    //
    //
    //
    //
    //
      
    manageAlerts();
    return(0);
    }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lb,2,y);
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         if(trend[i]!=trend[i+1])
            { 
               if(trend[i] ==  1) arrowUp[i] = Low[i]  - iATR(NULL,0,20,i);
               if(trend[i] == -1) arrowDn[i] = High[i] + iATR(NULL,0,20,i);
            }                                                     
   
    }
    
manageAlerts();
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
      
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Gann arrows ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Gann arrows "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

